divert(-1)
#
# Copyright (c) 1997 Jan Kr"uger <Jan.Krueger@stud.uni-hannover.de>
#
# In short: you can do whatever you want with this, but don't blame me!
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
divert(0)
ifdef(`_CHECK_HEADER_SUBJECT_', `ifdef(`_X_SPAM_HEADER_', `dnl', `dnl
errprint(`*** WARNING: Use _CHECK_HEADER_SUBJECT_ only with _X_SPAM_HEADER_.')')', `dnl')
ifdef(`ACCESS_TABLE', `dnl', `dnl
errprint(`*** ERROR: FEATURE(access_db) required for check_local.')')
ifdef(`_SPAM_FRIENDS_', `ifdef(`_SPAM_HATERS_', `dnl
errprint(`*** ERROR: check_local: use either _SPAM_FRIENDS_ or _SPAM_HATERS_. Not both.')', `dnl')', `ifdef(`_SPAM_HATERS_', `dnl', `dnl
errprint(`*** WARNING: check_local: use of _SPAM_FRIENDS_ or _SPAM_HATERS_ is recommended.')')')
ifdef(`_HC_SWITCH_', `dnl', `dnl
errprint(`*** WARNING: check_local _HC_SWITCH_ is recommended.')')
VERSIONID(`@(#)check_local.m4     (Jan Krueger) 1998-03-16')dnl
LOCAL_CONFIG
# ================== DATABASE =================================
# database definitions
# =============================================================
ifdef(`DATABASE_MAP_TYPE',, `define(`DATABASE_MAP_TYPE', `hash')')dnl
ifdef(`_SPAM_FRIENDS_',dnl
#map containing spam_friends e.g. postmaster
Kspam_friends ifelse(_SPAM_FRIENDS_, `',  
DATABASE_MAP_TYPE` /etc/mail/spam_friends', `_SPAM_FRIENDS_')
, `dnl')
ifdef(`_SPAM_HATERS_',dnl
#map containing spam_haters
Kspam_haters ifelse(_SPAM_HATERS_, `',  
DATABASE_MAP_TYPE` /etc/mail/spam_haters', `_SPAM_HATERS_')
, `dnl')
ifdef(`_HEADER_ACCESS_DB_',dnl
# definition of header_access (access.db for header_checking)
Kheader_access ifelse(_HEADER_ACCESS_DB_, `', 
DATABASE_MAP_TYPE` /etc/mail/header_access', `_HEADER_ACCESS_DB_')
, `dnl')
ifdef(`_RELAY_ACCESS_DB_',dnl
# definition of relay_access (access.db for check_relay)
Krelay_access ifelse(_RELAY_ACCESS_DB_, `', 
DATABASE_MAP_TYPE` /etc/mail/relay_access', `_RELAY_ACCESS_DB_')
, `dnl')
ifdef(`_HC_SWITCH_',dnl
# storage for switching the header_checking on/off
Khc_switch storage OFF
, `dnl')
# ================== ENVELOPE =================================
# definitions for extended checking of the envelope
# =============================================================
ifdef(`_REGEX_LOCALNUMS_',dnl
#regex for detecting numbers only
Kreg_numonly regex -a@MATCH ^[0-9]+$

#file containing domains without numbers only localpart
F{no_num_domains} ifelse(_REGEX_LOCALNUMS_, `', `/etc/mail/no_num_domains', `_REGEX_LOCALNUMS_')
, `dnl')
ifdef(`_REGEX_LOCALNUM_START_',dnl
#regex for detecting a leading digit
Kreg_numstart regex -a@MATCH ^[0-9]

#file containing domains without leading numbers in localpart
F{no_num_start_domains} ifelse(_REGEX_LOCALNUM_START_, `', `/etc/mail/no_num_start_domains', `_REGEX_LOCALNUM_START_')
, `dnl')
ifdef(`_CHECK_REGEX_',dnl
#regex for checking canonified mail_from
Kcheckregex regex -a@MATCH _CHECK_REGEX_
, `dnl')
ifdef(`_X_SPAM_ENVELOPE_', `dnl
# storage for header field X-Spam-Envelope
Kspam_env storage -hX-Spam-Envelope
', `dnl')
ifdef(`_MD5_MAGIC_KEY_', `dnl
#storage for md5_magic_key test
Kmd5_magic storage', `dnl') 
# ================== HEADER ===================================
# definitions for extended checking of the header
# =============================================================
ifdef(`_CHECK_HEADER_RECEIVED_', `
# pattern for received parsing
# it parses the following formats: 
# (a.b is a hostname or an IP with or without [])
# the keyword is optional
# from a.b
# from a.b (keyword a.b)
# from a.b (keyword a.b) (keyword a.b)
# from a.b (keyword a.b a.b)
# from a.b (keyword a.b) (keyword a.b a.b)
# returns 1 - 4 values delimited by $|
Kparse_received regex -s2,5,8,9 (^|[^(])from +([^() ]+) *(\(([^().@ ]+ +)?([^() ]+)\))? *(\(([^[().@ ]+ +)?([^() ]+)? *([^() ]+)?\))?
', `dnl')
ifdef(`_X_SPAM_HEADER_', `dnl
# storage defining a header field X-Spam-Header
Kspam_head storage -hX-Spam-Header
', `dnl')
ifdef(`_CHECK_HEADER_SUBJECT_', `dnl
# reg_subject regex for checking the subject
Kreg_subject regex -a@MATCH _CHECK_HEADER_SUBJECT_
', `dnl')
# pattern for ip parsing (appends <IP> if matching)
# it parses the following formats:
# abc@[1.2.3.4] abc@1.2.3.4 [1.2.3.4] 1.2.3.4
Kparse_ip regex -a<IP> -s2 ^([^@]+@)?\[?(([0-9]{1,3}\.){3}[0-9]{1,3})\]?$
LOCAL_RULESETS
ifdef(`_HEADER_ACCESS_DB_', `define(`_HEAD_AC_DB_', `header_access')', `define(`_HEAD_AC_DB_', `access')')dnl
ifdef(`_RELAY_ACCESS_DB_', `define(`_REL_AC_DB_', `relay_access')', `define(`_REL_AC_DB_', `access')')dnl
# ================== DATABASE =================================
# Ruleset ** MapLookUpDomain **
# like LookUpDomain with <$4> = name of map
# =============================================================
SMapLookUpDomain
R<$+> <$+>    <$*> <$+>		$: < $($4 $1 $: ? $) > <$1> <$2> <$3> <$4>
R<?>  <$+.$+> <$+> <$*> <$+>	$@ $>MapLookUpDomain <$2> <$3> <$4> <$5>
R<?>  <$+>    <$+> <$*> <$*>	$@ <$2> <$3>
R<$*> <$+>    <$+> <$*> <$*>	$@ <$1> <$4>

# ================== DATABASE =================================
# Ruleset ** MapLookUpDomain **
# like LookUpAddress with <$4> = name of map
# =============================================================
SMapLookUpAddress
R<$+> <$+>    <$*> <$+>		$: < $($4 $1 $: ? $) > <$1> <$2> <$3> <$4>
R<?>  <$+.$-> <$+> <$*> <$+>	$@ $>MapLookUpAddress <$1> <$3> <$4> <$5>
R<?>  <$+>    <$+> <$*> <$*>	$@ <$2> <$3>
R<$*> <$+>    <$+> <$*> <$*>	$@ <$1> <$4>

ifdef(`_RBL_',`dnl
# ================== DATABASE =================================
# Ruleset ** lookup_ip **
# lookup IP in (header_)access.db and in the RBL
# returns <(header_)access.db RHS> <> or if IP in RBL $#error 
# (privat to lookup)
# =============================================================
Slookup_ip
# is IP in header_access.db ?
R$+			$: $>MapLookUpAddress <$1> <?> <$1> <_HEAD_AC_DB_>
# no -> lookup rbl
R<?> <$*>		$: $1
# OK/RELAY -> no rbl lookup, return
R<OK> <$*>		$@ <OK> <>
R<RELAY> <$*>		$@ <RELAY> <>
# is IP in rbl ? 
R$-.$-.$-.$-		$: $(host $4.$3.$2.$1._RBL_ $: OK $) 
ROK			$@ no_problem
R$-.$-.$-.$-.$*		$#error $@ 5.7.1 $: "550 no access from " [$4.$3.$2.$1] " see http://maps.vix.com/rbl/"
', `dnl')
# ================== DATABASE =================================
# Ruleset ** lookup_address **
# lookup a@b.c, a@ and b.c with upper-domains in (header_)access.db
# returns <(header_)access.db RHS> <>
# (privat to lookup)
# =============================================================
Slookup_address
R$+<@$+>		$: <ADR $(_HEAD_AC_DB_ $1@$2 $: ? $)> $1 <$2>
R<ADR ?> $* <$*>	$: <ADR $(_HEAD_AC_DB_ $1@ $: ? $)> $1 <$2> 
R<ADR ?> $* <$*>	$: $>MapLookUpDomain <$2> <?> <> <_HEAD_AC_DB_>
R<ADR $+> $* <$*>	$: <$1> <>

# ================== DATABASE =================================
# Ruleset ** lookup **
# lookup recognizes IPs, addresses and hostnames 
# uses the rulesets lookup_ip and lookup_address
# returns the appropriate error 
# =============================================================
Slookup
# deal with format: Real Name <mail@address.dom>
R$*			$: < $1 > 
R$+ < $* >		< $2 >
R< $* > $+		< $1 >
R< $+ >			$: $1
# is this an IP ?
R$*			$: <> $(parse_ip $1 $)
# lookup IP 
R<> $-.$-.$-.$- <IP>	$: ifdef(`_RBL_', `$>lookup_ip $1.$2.$3.$4', `$>MapLookUpAddress <$1.$2.$3.$4> <?> <> <_HEAD_AC_DB_>')
# lookup address
R<> $+@$+		$: $>lookup_address $1<@$2>
# lookup hostname
R<> $+			$: $>MapLookUpDomain <$1> <?> <> <_HEAD_AC_DB_>
# deal with return values
R<?> <$*>		$@ no_problem
R<OK> <$*>		$@ no_problem
R<RELAY> <$*>		$@ no_problem
R<DISCARD> <$*>		$#discard $: discard
R<REJECT> <$*>		$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 Access denied.')
R<$+> <$*>		$#error $@ 5.7.1 $: $1

# ================== ENVELOPE =================================
# Ruleset ** check_reverse_path **
# is the reverse_path rfc821 conform?
# local@a.b,part@c.d is rejected
# =============================================================
Scheck_reverse_path
R$*@@$*		$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 MAIL FROM: Syntax error.')
R<$+>		$: $(dequote $1 $)
R@$+,$+		$2
R$+,$+		$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 MAIL FROM: Syntax error.')

# ================== ENVELOPE =================================
# Ruleset ** Extended_check_mail **
# =============================================================
SExtended_check_mail
# canonify
R$*			$: $>Parse0 $>3 $1
ifdef(`_REGEX_LOCALNUMS_', 
# digits only localpart ?
`R$+ < @ $={no_num_domains} . > $*
			$: $(reg_numonly $1 $) < @ $2 > $3', `dnl')
ifdef(`_REGEX_LOCALNUM_START_', 
# localpart with leading digit ?
`R$+ < @ $={no_num_start_domains} . > $*
			$: $(reg_numstart $1 $) < @ $2 > $3', `dnl')
ifdef(`_CHECK_REGEX_', 
# match address against regex
`R$* < @ $* > $*	$: $(checkregex $1<@$2>$3 $)', `dnl')
R@MATCH $*		$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 Access denied.')

# ================== ENVELOPE =================================
# Local_check_Rulesets
# =============================================================
SLocal_check_relay
# check_relay is done in Local_check_rcpt
R$*		$# OK

SLocal_check_mail
# check_mail is done in Local_check_rcpt
R$*		$# OK

# ================== ENVELOPE =================================
# Local_check_rcpt
# =============================================================
SLocal_check_rcpt
ifdef(`_CHECK_RCPT_HOOK_', `dnl
R$*		$: $1 $| $>ifelse(_CHECK_RCPT_HOOK_, `', `check_rcpt_hook', `_CHECK_RCTP_HOOK_') $1
R$* $| $#$*	$#$2
R$* $| $*	$: $1', `dnl')
# check for deferred delivery mode
R$*		$: < ${deliveryMode} > $1
R< d > $*	$@ deferred
R< $* > $*	$: $2
# +++++++++++++++ ok/relay part of check_relay +++++++
R$* 		$: $1 $| $>MapLookUpAddress <$&{client_addr}> <?> <> <_REL_AC_DB_>
R$* $| <?> <>	$: $1 $| $>MapLookUpDomain <$&{client_name}> <?> <> <_REL_AC_DB_>
R$* $| <OK> <>		$@ no_problem
R$* $| <RELAY> <>	$@ no_problem
R$* $| $*	$: $1
ifdef(`_RBL_ALL_', `ifdef(`_RBL_', `dnl
# +++++++++++++++ rbl_all section ++++++++++++++++++++
# MAPS project checks -- http://maps.vix.com/
R$*			$: $1 $| $&{client_addr}
R$* $| $-.$-.$-.$-	$: $1 $| <@> $(host $5.$4.$3.$2._RBL_. $: OK $)
R$* $| <@> OK		$: $1
R$* $| <@> $*		ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env rbl $)', `$#error $@ 5.7.1 $: "Mail from " $&{client_addr} " refused; see http://maps.vix.com/rbl/"')
R$* $| $*		$: $1', `dnl')', `dnl')
ifdef(`_MD5_MAGIC_KEY_', `dnl
# +++++++++++++++ md5_magic_key section ++++++++++++++
R<$+ + $+ @$=w>	$: <$(md5_magic $1+$2 $@ m $) @ $3>
R<@EQUAL@$*>	$@ md5_magic_ok', `dnl')
ifdef(`_SPAM_FRIENDS_', `dnl
# +++++++++++++++ spam_friend section ++++++++++++++++
# is the recipient a spam_friend ?
R<$+@$=w>			$: <?> $(spam_friends $1 $: @NOFRIEND $) <$1>
# is +option an opening key?
R<?> @NOFRIEND <$+ + $+>	$: <?> $(spam_friends +$2 $: @NOFRIEND $) 
# no, continue checking
R<?> @NOFRIEND $*		$: <> 
# yes, stop the check
R<?> $*				$@ spam_friend', `dnl')
ifdef(`_SPAM_HATERS_', `dnl
# +++++++++++++++ spam_hater section +++++++++++++++++
# is the recipient a spam_hater ?
R$*		$: $>Parse0 $>3 $1
# remove local parts
R$*<@$=w.>$*	$>3 $1 $3
# is +option an opening key?
R$+ + $*	$: $1 $| $(spam_haters +$2 $: @NOKEY $)
R$+ $| @NOKEY	$: $1
R$+ $| $*	$@ key_ok
R$+ 		$: $(spam_haters $1 $: @FRIEND $)
# no, stop the check
R@FRIEND	$@ no_hater', `dnl')
ifdef(`_HC_SWITCH_', `dnl
# hater or no spam_friend: turn header_checking ON
R$*		$: $(hc_switch ON $)', `dnl')
# ++++++++++++++++++ check_mail section ++++++++++++++++++++
R$*		$: <$&f>
R<<$*>>		<$1>
ifdef(`_MD2NAME_', 
`R<>		$: < $n @ $&{client_name} >', `dnl')
ifdef(`_CHECK_MAIL_HOOK_', `dnl
R<$+> 		$: <$1> $| $>ifelse(_CHECK_MAIL_HOOK_, `', `check_mail_hook', `_CHECK_MAIL_HOOK_') <$1>
R$* $| <OK>	$@ ifdef(`_HC_SWITCH_', `$(hc_switch OFF $)', `<OK>')
R$* $| <RELAY>	$@ ifdef(`_HC_SWITCH_', `$(hc_switch OFF $)', `<RELAY>')
R$* $| $#$*	ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env basic_check_mail $)', `$#$2')
R<$+> $| $*	$: <$1> $| $>Basic_check_mail <$1>',
`R<$+> 		$: <$1> $| $>Basic_check_mail <$1>')
R$* $| <OK>	$@ ifdef(`_HC_SWITCH_', `$(hc_switch OFF $)', `<OK>')
R$* $| <RELAY>	$@ ifdef(`_HC_SWITCH_', `$(hc_switch OFF $)', `<RELAY>')
R$* $| $#$*	ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env basic_check_mail $)', `$#$2')
R<$+> $| $*	$: <$1> $| $>check_reverse_path <$1>
R$*   $| $#$*	$#$2
R<$+> $| $*	$: <$1> $| $>Extended_check_mail <$1>
R$*   $| $#$*	ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env extended_check_mail $)', `$#$2')
# +++++++++++++++ reject part of check_relay +++++++++
# check_relay against (relay_)access.db
R$*		$: $>MapLookUpAddress <$&{client_addr}> <?> <> <_REL_AC_DB_>
R<?> <>		$: $>MapLookUpDomain <$&{client_name}> <?> <> <_REL_AC_DB_>
R<?> <>		$: <>
R<DISCARD> <>	$#discard $: discard
R<REJECT> <>	ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env relay_access $)', `$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 Access denied.')')
R<$+> <>	ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env relay_access $)', `$#error $@ 5.7.1 $: $1')
ifdef(`_RBL_', `ifdef(`_RBL_ALL_', `dnl', `dnl 
# +++++++++++++++ rbl section ++++++++++++++++++++++++
# MAPS project checks -- http://maps.vix.com/
R$*		$: $&{client_addr}
R$-.$-.$-.$-	$: <@> $(host $4.$3.$2.$1._RBL_. $: OK $)
R<@> OK		$: OK
R<@> $*		ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env rbl $)', `$#error $@ 5.7.1 $: "Mail from " $&{client_addr} " refused; see http://maps.vix.com/rbl/"')')', `dnl')
ifdef(`_CLIENT_MUST_RESOLVE_', `dnl
# +++++++++++++++ client_must_resolve section ++++++++
# does the client resolve in DNS ?
R$*		$: $&{client_name} <OK>
# Is IP ?
R[$+] <OK>	$: $1
# no, it is a hostname.
R$* <OK>	$@ no_problem
# yes. Is it a temporary problem?
R$+		$: $(resolve [ $1 ] $) 
# yes.
R$* <TEMP>	ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env resolve_tmp $)', `$#error $@ 4.1.8 $: 451 DNS failure. Client must resolve.')
# no.
R$* 		ifdef(`_X_SPAM_ENVELOPE_', `$@ $(spam_env resolve $)', `$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 Client must resolve.')')',
`dnl')

# ================== HEADER ===================================
# Definitions of check_header Rulesets
# =============================================================
ifdef(`_CHECK_HEADER_RECEIVED_', `HReceived: $>+check_received', `dnl')
ifdef(`_CHECK_HEADER_FROM_', `HFrom: $>check_from', `dnl')
ifdef(`_CHECK_HEADER_SENDER_', `HSender: $>check_from', `dnl')
ifdef(`_CHECK_HEADER_REPLY_TO_', `HReply-To: $>check_from', `dnl')
ifdef(`_CHECK_HEADER_TO_', `HTo: $>check_from', `dnl')
ifdef(`_CHECK_HEADER_CC_', `HCc: $>check_from', `dnl')
ifdef(`_CHECK_HEADER_COMMENTS_', `HComments: $>check_from', `dnl')
ifdef(`_CHECK_HEADER_MESSAGE_ID_', `HMessage-Id: $>check_message_id', `dnl')
ifdef(`_CHECK_HEADER_SUBJECT_', `HSubject: $>+check_subject', `dnl')
ifdef(`_CHECK_HEADER_CONTENT_', `HContent-Type: $>check_content', `dnl')


ifdef(`_CHECK_HEADER_RECEIVED_',`dnl
# ================== HEADER ===================================
# Ruleset ** check_received **
# =============================================================
Scheck_received
ifdef(`_HC_SWITCH_',`R$*			$: $1 $| <$(hc_switch $)>
R$* $| <OFF>		$@ hc_off
R$* $| $*		$: $1', `dnl')
# Parse the Received:-Line  with parse_received
R$*			$: $(parse_received $1 $)
# lookup 4th value
R$* $| $* $| $* $| $+ 	$: $1 $| $2 $| $3 $| $>lookup $4
R$* $| $* $| $* $| $#$*	ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "received 4" $)', `$#$4') 
# lookup 3rd value
R$* $| $* $| $+ $| $* 	$: $1 $| $2 $| $>lookup $3
R$* $| $* $| $#$*	ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "received 3" $)', `$#$3') 
# lookup 2nd value
R$* $| $+ $| $* 	$: $1 $| $>lookup $2 
R$* $| $#$*		ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "received 2" $)', `$#$2')
# lookup 1st value
R$+ $| $*		$: <dt> $>lookup $1 
R<dt> $#$*		ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "received 1" $)', `$#$1')
', `dnl')
ifdef(`_CHECK_HEADER_FROM_',`dnl
# ================== HEADER ===================================
# Ruleset ** multi_lookup **
# deal with To: a.b, c.d, e.f
# (privat to check_from)
# =============================================================
Smulti_lookup
R$+ , $+	$: $2 $| $>lookup $1
R$+ $| $#$*	$#$2
R$+ $| $*	$: $>multi_lookup $1
R$+		$: $>lookup $1

# ================== HEADER ===================================
# Ruleset ** check_from **
# =============================================================
Scheck_from
ifdef(`_HC_SWITCH_',`R$*			$: $1 $| <$(hc_switch $)>
R$* $| <OFF>		$@ hc_off
R$* $| $*		$: $1', `dnl')
R$*			$: <dt> $>multi_lookup $1
R<dt> $#$*		ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "from" $)', `$#$1')
', `dnl')
ifdef(`_CHECK_HEADER_MESSAGE_ID_', `dnl
# ================== HEADER ===================================
# Ruleset ** check_message_id **
# Is the format conform with rfc822 ?
# lookup the Message-Id: with ruleset lookup
# =============================================================
Scheck_message_id
ifdef(`_HC_SWITCH_',`R$*			$: $1 $| <$(hc_switch $)>
R$* $| <OFF>		$@ hc_off
R$* $| $*		$: $1', `dnl')
R$*			$: <@> $1
R<@> <$+@$+>		$: <$1@$2>
R<@> $*			ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "message-id_format" $)', `$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `552 Bad Message-Id. Check your configuration.')')
R$*			$: <dt> $>lookup $1
R<dt> $#$*		ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "message-id_lookup" $)', `$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 Access denied.')')
', `dnl')
ifdef(`_CHECK_HEADER_SUBJECT_', `dnl
# ================== HEADER ===================================
# Ruleset ** check_subject **
# Match the given argument against reg_subject 
# =============================================================
Scheck_subject
R$*		$: $(reg_subject $1 $)
R@MATCH		ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "subject" $)', `$#error $@ 5.7.1 $: ifdef(`confREJECT_MSG', `confREJECT_MSG', `550 Access denied.')')
', `dnl')
undefine(`_HEAD_AC_DB_')dnl
undefine(`_REL_AC_DB_')dnl
ifdef(`_CHECK_HEADER_CONTENT_', `dnl
# ================== HEADER ===================================
# Ruleset ** check_content **
# Reject mails containing HTML
# =============================================================
Scheck_content
R$* text/html $*	ifdef(`_X_SPAM_HEADER_', `$@ $(spam_head "content" $)', `$#error $@ 5.7.1 $: 552 HTML not accepted.')
', `dnl')
